var Player = function(){

	// Propriétés du joueur
	var x = 350;
	var y = 500;
	var v = 10;
	var width = 100;
	var height = 100;
	var color = 'black';
	var isShoot = false;
	var isSoundShoot = false;

	var imageObj = new Image();
	imageObj.src = 'img/player.png';

	// Dessine le joueur
	var draw = function(ctx){

        ctx.save();

        ctx.beginPath();
		ctx.drawImage(imageObj, x, y);

        if(isShoot){
        	ctx.beginPath();
	        ctx.rect(x+(width/2)-5, -110, 10, 600);
	        ctx.fillStyle = "red";
	        ctx.fill();
        }

        ctx.restore();
	};

	// Utilisé pour déplacer le joueur à droite
	var moveX1 = function(){
		x += v;
		if(x >= (800 - width)) x = 800 - width;
	};

	// Utilisé pour déplacer le joueur à gauche
	var moveX2 = function(){
		x -= v;
		if(x < 0) x = 0;
	};

	// Boost
	var boostOn = function(){
		v = 15;
	};
	var boostOff = function(){
		v = 10;
	};

	// Shoot
	var shootOn = function(){
		isShoot = true;
		playShootSound();
	};
	var shootOff = function(){
		isShoot = false;
		isSoundShoot = false;
		shootSound.stop();
	};

	// Retourne la position du shoot
	var getShootPosition = function(){
		return x + (width / 2) - 5;
	};

	// Replace le joueur à sa position initiale
	var resetPosition = function(){
		x = 350;
	};

	// Gestion du son de tir
	var playShootSound = function(){
		if(!isSoundShoot){
			shootSound.play().fadeIn(1.0, 300);
			isSoundShoot = true;
		}
	};

	// Retourne une API publique
    return {
    	x: x,
    	y: y,
    	v: v,
        draw: draw,
        moveX1: moveX1,
        moveX2: moveX2,
        boostOn: boostOn,
        boostOff: boostOff,
        shootOn: shootOn,
        shootOff: shootOff,
        getShootPosition: getShootPosition,
        resetPosition: resetPosition
    };
};