var S2NA = function(){

    var canvas, ctx, w, h; 
    var inputStates = {};

    var player = new Player();
    var ninjatab = [];
    var bloodtab = [];
	
    var timerpop;
    var memtimer;
    var timeroverload;
    var memtimeroverload;

    var score = 0;
    var combo = 0;
    var life = -1;
    var overload = 0;

	var startimg = new Image();
	startimg.src = "img/start.jpg";

	var backgroundimg = new Image();
	backgroundimg.src = "img/bg.jpg";

	var lifeimg = new Image();
	lifeimg.src = "img/life.png";

	var bloodimg = new Image();
	bloodimg.src = "img/blood.png";

	var backgroundgameover = new Image();
	backgroundgameover.src = "img/gameover.jpg";

    // Boucle principale
	var mainLoop = function(time){

		// Vider le canvas
		clearCanvas();

		if(life > 0){

			// Gestion des mouvements du joueur
			if (inputStates.right) player.moveX1();
			if (inputStates.left) player.moveX2();
			if (inputStates.boost) player.boostOn();
			if (!inputStates.boost) player.boostOff();

			if (!inputStates.shoot) player.shootOff();
			if(memtimeroverload != true){
				if (inputStates.shoot) player.shootOn();
			}
			else{
				if (inputStates.shoot) player.shootOff();
			}

			// Dessiner le background
			ctx.drawImage(backgroundimg, 0, 0);

			// Test de collision
			if(memtimeroverload != true){
				collisionShootNinja();
			}
			collisionNinjaSol();

			// Dessiner les tâches de sang
			for(var i = 0; i < bloodtab.length; i++){
				ctx.drawImage(bloodimg, bloodtab[i].x, bloodtab[i].y);
			}

			// Dessiner les ninjas
			for(var i = 0; i < ninjatab.length; i++){
				if(ninjatab[i].isActive()){
					ninjatab[i].draw(ctx);
				}
			}

			// Dessiner le joueur
			player.draw(ctx);

			// Afficher la barre de surcharge
			displayOverload();

			// Afficher le score
			displayScore();

			// Afficher le combo
			displayCombo();

			// Afficher les points de vie
			displayLife();
		}
		else if(life == 0){

			player.shootOff();
			displayGameOver();

			if (inputStates.enter) newGame();			
		}
		else{

			// Dessiner le menu start
			ctx.drawImage(startimg, 0, 0);
			if (inputStates.enter) newGame();
		}

		// Appeler la boucle d'animation
		requestAnimationFrame(mainLoop);
	};

	// (publique) Démarre le jeu
	var start = function(){

		// Initialisations
		canvas = document.querySelector("#game-container");
		ctx = canvas.getContext('2d');
		w = canvas.width;
		h = canvas.height;

		// Création des écouteurs
		addKeyListeners();

		// Création du stack de ninja
		initNinja(20);

		// Création d'un timer pour la gestion de l'apparition des ninjas
		createTimer(1500);

		// Démarrer l'animation
		requestAnimationFrame(mainLoop);
	};

	// Vide le contenu du canvas
	function clearCanvas() {

		ctx.save();
		ctx.clearRect(0, 0, w, h);
		ctx.restore();
	}

	// Evénements clavier
	function addKeyListeners() {

		window.addEventListener('keydown', function(e){
			switch(e.keyCode){
				case 13: inputStates.enter = true; break;
				case 32: inputStates.shoot = true; break;
				case 37: inputStates.left = true; break;
				case 39: inputStates.right = true; break;
				case 90: inputStates.boost = true; break;
			}
		});

		window.addEventListener('keyup', function(e){
			switch(e.keyCode){
				case 13: inputStates.enter = false; break;
				case 32: inputStates.shoot = false; break;
				case 37: inputStates.left = false; break;
				case 39: inputStates.right = false; break;
				case 90: inputStates.boost = false; break;
			}
		});
	}

	// Crée les ninjas
	function initNinja(n) {
		for(var i = 0; i < n; i++) {
			ninjatab[i] = new Ninja();
		}
	}

	// Collision des ninjas avec le sol
	function collisionNinjaSol() {

		for(var i = 0; i < ninjatab.length; i++) {

			if(ninjatab[i].getHeight() >= 600) {

				yaySound.play();
				ninjatab[i].setActive(false);
				ninjatab[i].setHeight();
				ninjatab[i].changeX();

				life--;
				if(life > 0){
					combo = 0;
				}
			}
		}
	}

	// Collision du shoot avec les ninjas
	function collisionShootNinja() {

		if (inputStates.shoot){

			var lim1, lim2, shoot;

			for(var i = 0; i < ninjatab.length; i++) {

				if(ninjatab[i].isActive()){

					lim1 = ninjatab[i].getX();
					lim2 = lim1 + 50;
					shoot = player.getShootPosition() + 5;

					if(shoot >= lim1 && shoot <= lim2){

						ninjadeathSound.play();
						bloodtab.push({x: lim1, y: ninjatab[i].getNinjaPos()});
						setTimeout(function(){
							bloodtab.shift();
						}, 10000);

						ninjatab[i].setActive(false);
						ninjatab[i].setHeight();
						ninjatab[i].changeX();

						combo++;
						score += combo * 7;
					}
				}
			}
		}
	}

	// Création du timer
	function createTimer(length){
		
		if(memtimer != length){
			
			clearInterval(timerpop);
			timerpop = setInterval(function(){
				for(var i = 0; i < ninjatab.length; i++){
					if(!ninjatab[i].isActive()){
						ninjatab[i].setActive(true);
						break;
					}
				}

				// Changement de palier de difficulté selon le score
				changeDifficulty();

			}, length);
			memtimer = length;
		}
	}

	// Changement du niveau de difficulté
	function changeDifficulty(){
		if(score > 500000) createTimer(600);
		else if(score > 250000) createTimer(650);
		else if(score > 100000) createTimer(700);
		else if(score > 50000) createTimer(750);
		else if(score > 20000) createTimer(800);
		else if(score > 10000) createTimer(850);
		else if(score > 7500) createTimer(800);
		else if(score > 5000) createTimer(950);
		else if(score > 2500) createTimer(1000);
		else if(score > 1500) createTimer(1100);
		else if(score > 1000) createTimer(1200);
		else if(score > 750) createTimer(1300);
		else if(score > 250) createTimer(1400);
	}

	// Affichage du score
	function displayScore(){
		ctx.beginPath();
		ctx.fillStyle = "white";
		ctx.font = "16px Arial";
		ctx.fillText("score", 27, 30);
		ctx.font = "30px Arial";
		ctx.fillText(score, 25, 60);
	}

	// Affichage du combo
	function displayCombo(){
		ctx.beginPath();
		ctx.fillStyle = "white";
		ctx.font = "16px Arial";
		ctx.fillText("combo", 25, 545);
		ctx.font = "30px Arial";
		ctx.fillText("x" + combo, 25, 575);
	}

	// Affichage des points de vie
	function displayLife(){
		ctx.beginPath();
		ctx.fillStyle = "white";
		ctx.font = "16px Arial";
		ctx.fillText("life", 690, 545);

		if(life > 0) ctx.drawImage(lifeimg, 690, 555);
		if(life > 1) ctx.drawImage(lifeimg, 720, 555);
		if(life > 2) ctx.drawImage(lifeimg, 750, 555);
	}

	// Afficher game over
	function displayGameOver(){
		ctx.beginPath();
		ctx.drawImage(backgroundgameover, 0, 0);

		ctx.beginPath();
		ctx.fillStyle = "white";
		ctx.font = "16px Arial";
		ctx.fillText("score", 502, 200);
		ctx.font = "30px Arial";
		ctx.fillText(score, 500, 230);
	}

	// Création du timer de la surcharge
	function createTimerOverload(){
		
		if(memtimeroverload != true){
			
			timeroverload = setTimeout(function(){
				memtimeroverload = false;
			}, 1200);
			
			memtimeroverload = true;
		}
	}

	// Afficher la barre de surcharge
	function displayOverload(){
        ctx.beginPath();
        ctx.rect(575, 30, 200, 15);
        ctx.fillStyle = "white";
        ctx.fill();
		ctx.stroke();

		if(memtimeroverload != true){
			if(inputStates.shoot){
				overload += 2;
				if(overload >= 194){
					overload = 194;
					createTimerOverload();
				}
			}
			if(!inputStates.shoot){
				if(overload > 0){
					overload -= 1;
				}
			}
		}

        ctx.beginPath();
        ctx.rect(578, 33, overload, 9);
		ctx.fillStyle = "red";
		ctx.fill();
	}

	// Démarrer une nouvelle partie
	function newGame(){

    	for(var i = 0; i < ninjatab.length; i++) {
			ninjatab[i].setActive(false);
			ninjatab[i].setHeight();
			ninjatab[i].changeX();
		}

    	score = 0;
    	combo = 0;
    	life = 3;
    	overload = 0;

    	player.resetPosition();
    	memtimeroverload = false;
    	clearTimeout(timeroverload);
    	createTimer(1500);
	}

	// Retourne une API publique
    return {
        start: start
    };
};